
package de.ivu.elect.presentation.entschaedigung.menu;

import javax.inject.Inject;

import de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public abstract class AbstractEntschaedigungsartMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private WahlSessionSelect wahlSelect;

  @Inject
  private WahlterminSessionSelect wahlterminSelect;

  @Inject
  private EntschaedigungsartMeta entschaedigungsartMeta;

  public AbstractEntschaedigungsartMenuItemEntry() {
    super();
  }

  protected EntschaedigungsartMeta getMeta() {
    return entschaedigungsartMeta;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getUseCasePermission());
  }

  @Override
  protected boolean isDisabledInternal() {
    return !wahlSelect.isSelected() && !wahlterminSelect.isSelected();
  }

  protected abstract UseCasePermission getUseCasePermission();

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }
}
